/*************************************************************************************

NORSE WARS v2.0

Random Map Script by Matei of Woad Creations ~ www.woadcreations.com


This script uses a lot of advanced features to create a randomly 
generated blood-style map with buyable units, technologies and god
powers using favor from kills. Players start in small bases around
a circular arena with a Healing Spring in the middle and must battle
for the favor of the gods to get soldiers or buy myth units, upgrades
and god powers.

Version 2.0 adds the following new features:
- A new skin: the Underworld, with its own units and GP's
- Random fast-paced battle music to keep you on your toes
- Civ bonuses to balance the three civs (all reduced costs rounded down): 
  - Odin: Free respawning Ravens, units +5% HP, units regenerate, GP's cost -5%
  - Thor: Armor/weapon upgrades cost -10%, starts with copper armor and shields
  - Loki: Myth units cost -20% and move 36% faster, Ulfsarks 10% faster
- Ulfsarks spawn faster
- Purchased units spawn faster, and more types of them are available: new Myth
  Units in each environment as well as more types of human units
- Hill Forts have larger LOS, more attack, and Crenellations, but less crush armor
- Several bug fixes


RULES:

- Every player controls a Hill Fort, and they lose if it is destroyed
- Players are all Norse and get favor when their human units fight
- Human units spawn for each player at their Hill Fort. The more
  favor the player has, the more types of units spawn.
- Favor may be paid on the store island behind players' bases to:
  - Buy a god power (available powers depend on the map)
  - Upgrade weapons, armor or shields (there's no limit to upgrades)
  - Buy a myth unit or hero (available units depend on the map)
  - Buy a special human soldier (available soldiers depend on the map)


FEATURES:

- Very fast download time due to small file size
- Supports anywhere from 2 to 12 players
- Four random skins: Greek, Egyptian, Norse and Underworld with
  different terrains, random buyable god powers and random buyable
  units based on thos environments
- Many strategies for victory: will you hoard favor to get more
  auto-spawning soldiers, buy weapons/armor to upgrade your troops,
  field an army of myth units, control the Healing Spring in the 
  center, or make use of god powers to defeat your opponents?
- Unique civilization bonuses (all reduced costs rounded down): 
  - Odin: Free respawning Ravens, units +5% HP, units regenerate, GP's cost -5%
  - Thor: Armor/weapon upgrades cost -10%, starts with copper armor and shields
  - Loki: Myth units cost -20% and move 36% faster, Ulfsarks 10% faster
- Random fast-paced battle music to keep you on your toes
- Unlimited replayability: every map generated is different
- Countless hours of fast-paced fun!


HOW TO HOST A GAME:

- Norse Wars should be played mutiplayer with human players, as
  computer players don't know how to use favor to buy things
- Host a game using ESO Advanced Setup or LAN/DirectIP
- Select Supremacy under Game Type
- Press Other Settings and set Visibility to Revealed
  (this is not necessary but it's useful)
- Click Select Map and choose Norse Wars 2.0 from the list
- All players must be Norse to get favor from fighting


TO OTHER SCRIPTERS:

- You are free to use this script or parts of it in your own work,
  but PLEASE GIVE CREDIT TO THE ORIGINAL AUTHOR (MATEI) IF YOU DO SO!
  Use a script comment and an in-game text message.
- If you want to edit the map, PLEASE DO NOT MODIFY THIS FILE.
  Copy the file and rename it, so that there aren't any file name
  conflicts with people who don't have your edited version.
- If you have any questions about the map, post then in the Woad
  Creations forums at www.woadcreations.com.


ACKNOWLEDGEMENTS:

I would like to thank the following people:
- The members of Woad Creations, especially Shiva, Lp_USA, and Yhagoro, for
  their playtesting and their excellent advice on all aspects of the map
- The VinaCIS clan, for some of the balance suggestions for Norse Wars
- The makers of SCNPunk's Troy Massacre, where I got the random battle
  music idea from (Troy Massacre is really a blast to play!)
- And last but not least, all the Norse Wars fans on ESO. It's great to
  see that people enjoy playing this map as much as I enjoyed making it :)

*************************************************************************************/


// Tech ID constants

int cTechMediumArchers=3;
int cTechHeavyArchers=4;
int cTechChampionArchers=5;
int cTechMediumInfantry=6;
int cTechHeavyInfantry=7;
int cTechChampionInfantry=8;
int cTechCopperWeapons=12;
int cTechBronzeWeapons=13;
int cTechIronWeapons=14;
int cTechCopperMail=15;
int cTechBronzeMail=16;
int cTechIronMail=17;
int cTechCopperShields=18;
int cTechBronzeShields=19;
int cTechIronShields=20;
int cTechMediumCavalry=24;
int cTechHeavyCavalry=25;
int cTechChampionCavalry=26;
int cTechBoilingOil=30;
int cTechBurningPitch=32;
int cTechMasons=33;
int cTechRampage=47;
int cTechRime=56;
int cTechArchitects=60;
int cTechGraniteBlood=72;
int cTechHamarrtroll=73;
int cTechCriosphinx=74;
int cTechHieracosphinx=75;
int cTechMonstrousRage=76;
int cTechBacchanalia=78;
int cTechSylvanLore=80;
int cTechAuroraBorealis=91;
int cTechHandofTalos=102;
int cTechFeetoftheJackal=115;
int cTechAge2Forseti=117;
int cTechAge2Heimdall=118;
int cTechAge2Freyja=119;
int cTechAge3Skadi=120;
int cTechAge3Bragi=121;
int cTechAge3Njord=122;
int cTechAge4Hel=123;
int cTechAge4Baldr=124;
int cTechAge4Tyr=125;
int cTechSignalFires=126;
int cTechShoulderofTalos=128;
int cTechFaceoftheGorgon=131;
int cTechLoneWanderer=163;
int cTechHeavyCamelry=173;
int cTechChampionCamelry=174;
int cTechRelicWedjatEye=205;
int cTechRelicNoseoftheSphinx=206;
int cTechEldhrimnirKettle=208;
int cTechEclipse=215;
int cTechWillofKronos=216;
int cTechLabyrinthofMinos=217;
int cTechFlamesofTyphon=218;
int cTechDivineBlood=219;
int cTechCrocodopolis=256;
int cTechRelicEyeofOrnlu=266;
int cTechRoarofOrthus=269;
int cTechAtefCrown=270;
int cTechChampionElephants=275;
int cTechHallofThanes=276;
int cTechRelicPandorasBox=295;
int cTechOracle=299;
int cTechMediumAxemen=307;
int cTechHeavyAxemen=308;
int cTechChampionAxemen=309;
int cTechMediumSpearmen=310;
int cTechHeavySpearmen=311;
int cTechChampionSpearmen=312;
int cTechHeavyChariots=313;
int cTechChampionChariots=314;
int cTechHeavyElephants=315;
int cTechMediumSlingers=320;
int cTechHeavySlingers=321;
int cTechChampionSlingers=322;
int cTechThurisazRune=329;
int cTechRelicTowerofSestus=333;
int cTechRelicArrowsofAlfar=209;
int cTechWeaponoftheTitans=347;
int cTechAge2Fake=348;
int cTechAge3Fake=349;
int cTechAge4Fake=350;
int cTechCrenellations=351;
int cTechRelicBootsofKickEverything=368;
int cTechRelicCatoblepasScales=373;
int cTechRelicTailofCerberus=374;
int cTechEclipseActive=378;
int cTechStartingResourcesEgyptian=382;
int cTechStartingResourcesGreek=383;
int cTechStartingResourcesNorse=384;

// Tech status constants

int cTechStatusUnobtainable=0;
int cTechStatusObtainable=1;
int cTechStatusAvailable=2;
int cTechStatusResearching=3;
int cTechStatusActive=4;
int cTechStatusPersistent=5;

// Unit stance constants

int cUnitStanceAggressive=0;
int cUnitStanceDefensive=1;
int cUnitStancePassive=2;

// Armies array

int army1=0; int army2=0; int army3=0; int army4=0;
int army5=0; int army6=0; int army7=0; int army8=0;
int army9=0; int army10=0; int army11=0; int army12=0;
int getArmy(int p=1) {
	if(p==1) {return(army1);} else if(p==2) {return(army2);} else if(p==3) {return(army3);} 
	else if(p==4) {return(army4);} else if(p==5) {return(army5);} else if(p==6) {return(army6);}
	else if(p==7) {return(army7);} else if(p==8) {return(army8);} else if(p==9) {return(army9);} 
	else if(p==10) {return(army10);} else if(p==11) {return(army11);} else if(p==12) {return(army12);}
}
void setArmy(int p=1, int v=0) {
	if(p==1) {army1 = v;} else if(p==2) {army2 = v;} else if(p==3) {army3 = v;} 
	else if(p==4) {army4 = v;} else if(p==5) {army5 = v;} else if(p==6) {army6 = v;} 
	else if(p==7) {army7 = v;} else if(p==8) {army8 = v;} else if(p==9) {army9 = v;} 
	else if(p==10) {army10 = v;} else if(p==11) {army11 = v;} else if(p==12) {army12 = v;} 
}

// Homes array

int home1=0; int home2=0; int home3=0; int home4=0;
int home5=0; int home6=0; int home7=0; int home8=0;
int home9=0; int home10=0; int home11=0; int home12=0;
int getHome(int p=1) {
	if(p==1) {return(home1);} else if(p==2) {return(home2);} else if(p==3) {return(home3);} 
	else if(p==4) {return(home4);} else if(p==5) {return(home5);} else if(p==6) {return(home6);}
	else if(p==7) {return(home7);} else if(p==8) {return(home8);} else if(p==9) {return(home9);} 
	else if(p==10) {return(home10);} else if(p==11) {return(home11);} else if(p==12) {return(home12);}
}
void setHome(int p=1, int v=0) {
	if(p==1) {home1 = v;} else if(p==2) {home2 = v;} else if(p==3) {home3 = v;} 
	else if(p==4) {home4 = v;} else if(p==5) {home5 = v;} else if(p==6) {home6 = v;} 
	else if(p==7) {home7 = v;} else if(p==8) {home8 = v;} else if(p==9) {home9 = v;} 
	else if(p==10) {home10 = v;} else if(p==11) {home11 = v;} else if(p==12) {home12 = v;} 
}

// Monuments array

string monument1=""; string monument2=""; string monument3=""; string monument4="";
string monument5=""; string monument6=""; string monument7=""; string monument8="";
string monument9=""; string monument10=""; string monument11=""; string monument12="";
string getMonument(int p=1) {
	if(p==1) {return(monument1);} else if(p==2) {return(monument2);} else if(p==3) {return(monument3);} 
	else if(p==4) {return(monument4);} else if(p==5) {return(monument5);} else if(p==6) {return(monument6);}
	else if(p==7) {return(monument7);} else if(p==8) {return(monument8);} else if(p==9) {return(monument9);} 
	else if(p==10) {return(monument10);} else if(p==11) {return(monument11);} else if(p==12) {return(monument12);}
}
void setMonument(int p=1, string v="") {
	if(p==1) {monument1 = v;} else if(p==2) {monument2 = v;} else if(p==3) {monument3 = v;} 
	else if(p==4) {monument4 = v;} else if(p==5) {monument5 = v;} else if(p==6) {monument6 = v;} 
	else if(p==7) {monument7 = v;} else if(p==8) {monument8 = v;} else if(p==9) {monument9 = v;} 
	else if(p==10) {monument10 = v;} else if(p==11) {monument11 = v;} else if(p==12) {monument12 = v;} 
}

// Starts array

string start1=""; string start2=""; string start3=""; string start4="";
string start5=""; string start6=""; string start7=""; string start8="";
string start9=""; string start10=""; string start11=""; string start12="";
string getStart(int p=1) {
	if(p==1) {return(start1);} else if(p==2) {return(start2);} else if(p==3) {return(start3);} 
	else if(p==4) {return(start4);} else if(p==5) {return(start5);} else if(p==6) {return(start6);}
	else if(p==7) {return(start7);} else if(p==8) {return(start8);} else if(p==9) {return(start9);} 
	else if(p==10) {return(start10);} else if(p==11) {return(start11);} else if(p==12) {return(start12);}
}
void setStart(int p=1, string v="") {
	if(p==1) {start1 = v;} else if(p==2) {start2 = v;} else if(p==3) {start3 = v;} 
	else if(p==4) {start4 = v;} else if(p==5) {start5 = v;} else if(p==6) {start6 = v;} 
	else if(p==7) {start7 = v;} else if(p==8) {start8 = v;} else if(p==9) {start9 = v;} 
	else if(p==10) {start10 = v;} else if(p==11) {start11 = v;} else if(p==12) {start12 = v;} 
}

// SpecialXs array

float specialX1=0; float specialX2=0; float specialX3=0; float specialX4=0;
float specialX5=0; float specialX6=0; float specialX7=0; float specialX8=0;
float specialX9=0; float specialX10=0; float specialX11=0; float specialX12=0;
float getSpecialX(float p=1) {
	if(p==1) {return(specialX1);} else if(p==2) {return(specialX2);} else if(p==3) {return(specialX3);} 
	else if(p==4) {return(specialX4);} else if(p==5) {return(specialX5);} else if(p==6) {return(specialX6);}
	else if(p==7) {return(specialX7);} else if(p==8) {return(specialX8);} else if(p==9) {return(specialX9);} 
	else if(p==10) {return(specialX10);} else if(p==11) {return(specialX11);} else if(p==12) {return(specialX12);}
}
void setSpecialX(float p=1, float v=0) {
	if(p==1) {specialX1 = v;} else if(p==2) {specialX2 = v;} else if(p==3) {specialX3 = v;} 
	else if(p==4) {specialX4 = v;} else if(p==5) {specialX5 = v;} else if(p==6) {specialX6 = v;} 
	else if(p==7) {specialX7 = v;} else if(p==8) {specialX8 = v;} else if(p==9) {specialX9 = v;} 
	else if(p==10) {specialX10 = v;} else if(p==11) {specialX11 = v;} else if(p==12) {specialX12 = v;} 
}

// SpecialZs array

float specialZ1=0; float specialZ2=0; float specialZ3=0; float specialZ4=0;
float specialZ5=0; float specialZ6=0; float specialZ7=0; float specialZ8=0;
float specialZ9=0; float specialZ10=0; float specialZ11=0; float specialZ12=0;
float getSpecialZ(float p=1) {
	if(p==1) {return(specialZ1);} else if(p==2) {return(specialZ2);} else if(p==3) {return(specialZ3);} 
	else if(p==4) {return(specialZ4);} else if(p==5) {return(specialZ5);} else if(p==6) {return(specialZ6);}
	else if(p==7) {return(specialZ7);} else if(p==8) {return(specialZ8);} else if(p==9) {return(specialZ9);} 
	else if(p==10) {return(specialZ10);} else if(p==11) {return(specialZ11);} else if(p==12) {return(specialZ12);}
}
void setSpecialZ(float p=1, float v=0) {
	if(p==1) {specialZ1 = v;} else if(p==2) {specialZ2 = v;} else if(p==3) {specialZ3 = v;} 
	else if(p==4) {specialZ4 = v;} else if(p==5) {specialZ5 = v;} else if(p==6) {specialZ6 = v;} 
	else if(p==7) {specialZ7 = v;} else if(p==8) {specialZ8 = v;} else if(p==9) {specialZ9 = v;} 
	else if(p==10) {specialZ10 = v;} else if(p==11) {specialZ11 = v;} else if(p==12) {specialZ12 = v;} 
}

// Environment stuff

int env = 0;

int NORSE_ENV = 1;
int EGYPTIAN_ENV = 2;
int GREEK_ENV = 3;
int HADES_ENV = 4;

int POP_LIMIT = 160;

int NUM_MUSICS = 40;

string tPlayer = "";
string tConn = "";
string tMiddle = "";
string tDecoPatch = "";
string tForest = "";
string tBlack = "";
string tCliff = "";
string tBlackPatch = "";
string tBlackPatch2 = "";
float fBaseHeight = 0.0;
string sLight = "";
string sSea = "";
string sDeco1 = "";
string sDeco2 = "";
string sBlackPatchDeco = "";
int iBlackPatchDecoAmount = 0;
string sMU2 = "";
int iMU2Cost = 0;
string sMU1 = "";
int iMU1Cost = 0;
string sHero = "";
int sHeroCost = 0;
string sSoldier1 = "";
int iSoldier1Cost = 0;
string sSoldier2 = "";
int iSoldier2Cost = 0;
string sEnvUnitsDesc = "";
string sEnvPower = "";
string iEnvPowerCaster = "";
string sEnvPowerDesc = "";
int iEnvPowerCost = 0;

// Utility functions

float abs(float x = 0) {
	if(x<0) {return(0.0-x);} else {return(x);}
}

string pointLoc(float fracX = 0, float fracZ = 0) {
	return(""+rmXFractionToMeters(fracX)+",0,"+
	rmZFractionToMeters(fracZ));
}

string playerLoc(int i=1) {
	return(pointLoc(rmPlayerLocXFraction(i), rmPlayerLocZFraction(i)));
}

string playerGatherLoc(int i=1) {
	float fx = (0.5 - rmXTilesToFraction(12))/0.5;
	float fz = (0.5 - rmZTilesToFraction(12))/0.5;
	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
			(rmPlayerLocZFraction(i)-0.5)*fz+0.5));
}

string playerSpawnLoc(int i=1) {
	float fx = (0.5 - rmXTilesToFraction(4))/0.5;
	float fz = (0.5 - rmZTilesToFraction(4))/0.5;
	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
			(rmPlayerLocZFraction(i)-0.5)*fz+0.5));
}

string playerIslandLoc(int i=1) {
	float fx = (0.5 + rmXTilesToFraction(36))/0.5;
	float fz = (0.5 + rmZTilesToFraction(36))/0.5;
	return(pointLoc((rmPlayerLocXFraction(i)-0.5)*fx+0.5,
			(rmPlayerLocZFraction(i)-0.5)*fz+0.5));
}

void addRavens(int time=0) {
	for(i=1; <cNumberPlayers) {
		int count = 0;
		if(rmGetPlayerCiv(i) == cCivOdin) {
			count = 2;
		}
	
		for(j=0; <count) {
			// create army
			int army = rmCreateArmy(i, "raven"+j+"_p"+i);
		
			// create trigger
			int id = rmCreateTrigger("raven"+j+"_p"+i);
			rmSwitchToTrigger(id);
			rmSetTriggerLoop(true);
			rmSetTriggerPriority(3);
			rmAddTriggerCondition("Army Is Dead");
			 rmSetTriggerConditionParamArmy("SrcArmy", i, army, false);
			rmAddTriggerCondition("Army Is Alive");
			 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
			rmAddTriggerCondition("Timer");
			 rmSetTriggerConditionParamInt("Param1", time, false);
			rmAddTriggerCondition("Units In Area");
			 rmSetTriggerConditionParamInt("Player", i, false);
			 rmSetTriggerConditionParam("DstObject", getStart(i), false);
			 rmSetTriggerConditionParam("UnitType", "Hill Fort", false);
			 rmSetTriggerConditionParam("Op", ">=", false);
			 rmSetTriggerConditionParamFloat("Dist", 10.0, false);
			 rmSetTriggerConditionParamInt("Count", 1, false);
			rmAddTriggerEffect("Army Deploy");
			 rmSetTriggerEffectParamArmy("SrcArmy", i, army, false);
			 rmSetTriggerEffectParam("ProtoName", "Raven", false);
			 rmSetTriggerEffectParamInt("Count", 1, false);
			 rmSetTriggerEffectParamInt("Heading", 0, false);
			 rmSetTriggerEffectParam("Clear", "true", false);
			 rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
			rmAddTriggerEffect("Army Move");
			 rmSetTriggerEffectParamArmy("SrcArmy", i, army, false);
			 rmSetTriggerEffectParam("DstPoint", playerGatherLoc(i), false);
			 rmSetTriggerEffectParam("AttackMove", "false", false);
		 }
	}
}

void addSpawningUnit(string name="", int count=0, int time=0, int favor=0) {
	for(i=1; <cNumberPlayers) {
		int id = rmCreateTrigger("fav"+favor+"_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", time, false);
		rmAddTriggerCondition("Player Resource Count");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Resource", "favor", false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamInt("Count", favor, false);
		rmAddTriggerCondition("Player Population");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Op", "<", false);
		 rmSetTriggerConditionParamInt("Count", POP_LIMIT, false);
		rmAddTriggerCondition("Army Is Alive");
		 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
		rmAddTriggerCondition("Units In Area");
		 rmSetTriggerConditionParamInt("Player", i, false);
		 rmSetTriggerConditionParam("DstObject", getStart(i), false);
		 rmSetTriggerConditionParam("UnitType", "Hill Fort", false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamFloat("Dist", 10.0, false);
		 rmSetTriggerConditionParamInt("Count", 1, false);
		rmAddTriggerEffect("Army Deploy");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("ProtoName", name, false);
		 rmSetTriggerEffectParamInt("Count", count, false);
		 rmSetTriggerEffectParamInt("Heading", 0, false);
		 rmSetTriggerEffectParam("Clear", "true", false);
		 rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
		rmAddTriggerEffect("Army Move");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("DstPoint", playerGatherLoc(i), false);
		 rmSetTriggerEffectParam("AttackMove", "true", false);
	}
}

void addBuyableUnit(string name="", int favor=0, int isMyth=0) {
	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Loki -20% bonus)
		int cost = favor;
		if(isMyth==1 && rmGetPlayerCiv(i)==cCivLoki) {
			cost = cost * 80 / 100;
		}
	
		// create the summoner object
		int id=rmCreateObjectDef("buy"+favor+"_"+name+"_"+i);
		rmAddObjectDefItem(id, name, 1, 0.0);
		rmSetObjectDefMinDistance(id, 6.0);
		rmSetObjectDefMaxDistance(id, 10.0);
		rmPlaceObjectDefAtLoc(id, i, getSpecialX(i), getSpecialZ(i));
		
		// create the buy trigger
		id = rmCreateTrigger("buy"+favor+"_"+name+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 1, false);
		rmAddTriggerCondition("Player Resource Count");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Resource", "favor", false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamInt("Count", cost, false);
		rmAddTriggerCondition("Player Population");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Op", "<", false);
		 rmSetTriggerConditionParamInt("Count", POP_LIMIT, false);
		rmAddTriggerCondition("Army Is Alive");
		 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
		rmAddTriggerCondition("Units In Area");
		 rmSetTriggerConditionParamInt("Player", i, false);
		 rmSetTriggerConditionParam("DstObject", getMonument(i), false);
		 rmSetTriggerConditionParam("UnitType", name, false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamFloat("Dist", 3.5, false);
		 rmSetTriggerConditionParamInt("Count", 1, false);
		rmAddTriggerEffect("Grant Resources");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParam("ResName", "favor", false);
		 rmSetTriggerEffectParamInt("Amount", 0-cost, false);
		rmAddTriggerEffect("Army Deploy");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("ProtoName", name, false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParamInt("Heading", 0, false);
		 rmSetTriggerEffectParam("Clear", "true", false);
		 rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
		rmAddTriggerEffect("Army Move");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("DstPoint", playerGatherLoc(i), false);
		 rmSetTriggerEffectParam("AttackMove", "true", false);
		rmAddTriggerEffect("Army Deploy");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("ProtoName", "Hero Death", false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParamInt("Heading", 0, false);
		 rmSetTriggerEffectParam("Clear", "true", false);
		 rmSetTriggerEffectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)), false);
	}
}

void addGodPowerUnit(string unit="", string power="", int favor=0) {
	string displayName = power;
	if(power=="SandStorm") {displayName = "Shifting Sands";}
	if(power=="Skeleton Power") {displayName = "Ancestors";}

	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Odin -5% bonus)
		int cost = favor;
		if(rmGetPlayerCiv(i)==cCivOdin) {
			cost = cost * 95 / 100;
		}
	
		// create the summoner object
		int id=rmCreateObjectDef("gp"+favor+"_"+power+"_"+i);
		rmAddObjectDefItem(id, unit, 1, 0.0);
		rmSetObjectDefMinDistance(id, 6.0);
		rmSetObjectDefMaxDistance(id, 10.0);
		rmPlaceObjectDefAtLoc(id, i, getSpecialX(i), getSpecialZ(i));
		
		// create the buy trigger
		id = rmCreateTrigger("buy"+favor+"_"+power+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 4, false);
		rmAddTriggerCondition("Player Resource Count");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Resource", "favor", false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamInt("Count", cost, false);
		rmAddTriggerCondition("Army Is Alive");
		 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
		rmAddTriggerCondition("Units In Area");
		 rmSetTriggerConditionParamInt("Player", i, false);
		 rmSetTriggerConditionParam("DstObject", getMonument(i), false);
		 rmSetTriggerConditionParam("UnitType", unit, false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamFloat("Dist", 3.5, false);
		 rmSetTriggerConditionParamInt("Count", 1, false);
		rmAddTriggerEffect("Grant Resources");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParam("ResName", "favor", false);
		 rmSetTriggerEffectParamInt("Amount", 0-cost, false);
		rmAddTriggerEffect("Grant God Power");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParam("PowerName", power, false);
		rmAddTriggerEffect("Send Spoofed Chat");
		 rmSetTriggerEffectParam("Message", "<Player "+i+" has purchased a "+displayName+"!>", false);
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		rmAddTriggerEffect("Sound Filename");
		 rmSetTriggerEffectParam("Sound", "lightningstrike3.wav", false);
		rmAddTriggerEffect("Army Deploy");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("ProtoName", "Hero Birth", false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParamInt("Heading", 0, false);
		 rmSetTriggerEffectParam("Clear", "true", false);
		 rmSetTriggerEffectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)), false);
	}
}

void addTechUnit(string unit="", int tech=0, int favor=0) {
	for(i=1; <cNumberPlayers) {
		// figure out the true cost for this player (for Thor -10% bonus)
		int cost = favor;
		if(rmGetPlayerCiv(i)==cCivThor) {
			cost = cost * 90 / 100;
		}
	
		// create the summoner object
		int id=rmCreateObjectDef("tech"+favor+"_"+tech+"_"+i);
		rmAddObjectDefItem(id, unit, 1, 0.0);
		rmSetObjectDefMinDistance(id, 6.0);
		rmSetObjectDefMaxDistance(id, 10.0);
		rmPlaceObjectDefAtLoc(id, i, getSpecialX(i), getSpecialZ(i));
		
		// create the buy trigger
		id = rmCreateTrigger("tech"+favor+"_"+tech+"_p"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerLoop(true);
		rmSetTriggerPriority(3);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 2, false);
		rmAddTriggerCondition("Player Resource Count");
		 rmSetTriggerConditionParamInt("PlayerID", i, false);
		 rmSetTriggerConditionParam("Resource", "favor", false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamInt("Count", cost, false);
		rmAddTriggerCondition("Army Is Alive");
		 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
		rmAddTriggerCondition("Units In Area");
		 rmSetTriggerConditionParamInt("Player", i, false);
		 rmSetTriggerConditionParam("DstObject", getMonument(i), false);
		 rmSetTriggerConditionParam("UnitType", unit, false);
		 rmSetTriggerConditionParam("Op", ">=", false);
		 rmSetTriggerConditionParamFloat("Dist", 3.5, false);
		 rmSetTriggerConditionParamInt("Count", 1, false);
		rmAddTriggerEffect("Grant Resources");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParam("ResName", "favor", false);
		 rmSetTriggerEffectParamInt("Amount", 0-cost, false);
		rmAddTriggerEffect("Set Tech Status");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParamInt("TechID", tech, false);
		 rmSetTriggerEffectParamInt("Status", cTechStatusActive, false);
		rmAddTriggerEffect("Army Deploy");
		 rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
		 rmSetTriggerEffectParam("ProtoName", "Regeneration SFX", false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParamInt("Heading", 0, false);
		 rmSetTriggerEffectParam("Clear", "true", false);
		 rmSetTriggerEffectParam("Location", pointLoc(getSpecialX(i), getSpecialZ(i)), false);
	}
}

void grantTech(int i=1, int tech=0) {
	rmAddTriggerEffect("Set Tech Status");
	 rmSetTriggerEffectParamInt("PlayerID", i, false);
	 rmSetTriggerEffectParamInt("TechID", tech, false);
	 rmSetTriggerEffectParamInt("Status", cTechStatusActive, false);
}

void removeTech(int i=1, int tech=0) {
	rmAddTriggerEffect("Set Tech Status");
	 rmSetTriggerEffectParamInt("PlayerID", i, false);
	 rmSetTriggerEffectParamInt("TechID", tech, false);
	 rmSetTriggerEffectParamInt("Status", cTechStatusUnobtainable, false);
}

void sendChat(string message="", int player=0) {
	rmAddTriggerEffect("Send Spoofed Chat");
	 rmSetTriggerEffectParam("Message", message, false);
	 rmSetTriggerEffectParamInt("PlayerID", player, false);
}

string chooseRand2(string s1="", string s2="") {
	int r = rmRandInt(1,2);
	if(r==1) {return(s1);} else {return(s2);}
}

string chooseRand3(string s1="", string s2="", string s3="") {
	int r = rmRandInt(1,3);
	if(r==1) {return(s1);} else if(r==2) {return(s2);} else {return(s3);}
}

string chooseRand4(string s1="", string s2="", string s3="", string s4="") {
	return(chooseRand2(chooseRand2(s1,s2), chooseRand2(s3,s4)));
}

void main(void) 
{
	// map generation progress
	rmSetStatusText("",0.01);
	
	int i=0; int j=0; int k=0; int l=0; int id = 0; float sz = 0;
	float fx = 0; float fz = 0;
	string name1=""; string name2=""; string name3=""; string name4="";
	int nextMusicID = 0; int secondMusicID = 0; int lastMusicID = 0;

	// set size
	int playerTiles=1200;
	if(cMapSize == 1)
	{
		rmEchoInfo("Ignoring Large map size - all maps should be same size");
	}
	int sizeX=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles+19000);
	int sizeZ=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles+19000);
	rmEchoInfo("Map size="+sizeX+"m x "+sizeZ+"m");
	rmSetMapSize(sizeX, sizeZ);

	// set sea level
	rmSetSeaLevel(0.0);

	// choose an environment
	env = rmRandInt(1,4);
	
	// set map settings based on environment
	if(env==NORSE_ENV) {
		tBlack = "water";
		sSea = "Norwegian Sea";
		tPlayer = "norseRoadA";
		tConn = "norseRoadA";
		tMiddle = "snowGrass50";
		tDecoPatch = chooseRand2("snowGrass25", "snowGrass75");
		tForest = "Mixed Pine Forest";
		
		sLight = "default";
		
		sDeco1 = "Rock Granite Sprite";
		sDeco2 = "Rock River Icy";

		sHero = "Hero Norse";
		sHeroCost = 4;
		sSoldier1 = chooseRand2("Jarl", "Huskarl");
		iSoldier1Cost = 2;
		sSoldier2 = "Ballista";
		iSoldier2Cost = 4;
		sMU1 = chooseRand3("Troll", "Valkyrie", "Fenris Wolf");
		if(sMU2=="Troll") {iMU1Cost = 3;} else {iMU1Cost = 4;}
		sMU2 = chooseRand3("Battle Boar", "Frost Giant", "Fire Giant");
		if(sMU2=="Battle Boar") {iMU2Cost = 9;} 
		else if(sMU2=="Frost Giant") {iMU2Cost = 11;} 
		else {iMU2Cost = 13;}

		name1 = "Jarl"; if(sSoldier1=="Huskarl") {name1="Husk.";}
		name3 = "F.Wolf"; if(sMU1!="Fenris Wolf") {name3=sMU1;}
		name2 = "B.Boar(9)";   if(sMU2=="Frost Giant") {name2="Fr.Giant(11)";}
				if(sMU2=="Fire Giant") {name2="Fi.Giant(13)";}
		sEnvUnitsDesc = "Hersir(4), "+name1+"(2), Ballista(4), "+name3+"("+iMU1Cost+"), "+name2;
		
		sEnvPower = chooseRand2("Flaming Weapons", "Frost");
		iEnvPowerCaster = "Reginleif";
		iEnvPowerCost = 35; if(sEnvPower=="Flaming Weapons") {iEnvPowerCost=40;}

		if(sEnvPower=="Flaming Weapons") {sEnvPowerDesc = "Reginleif=Fl.Weapons(40)"; }
		else {sEnvPowerDesc = "Reginleif=Frost(35)"; }
	}
	else if(env==EGYPTIAN_ENV) {
		tBlack = "water";
		sSea = "Red Sea";
		tPlayer = "egyptianRoadA";
		tConn = "egyptianRoadA";
		tMiddle = chooseRand4("sandA", "sandB", "sandC", "sandD");
		tDecoPatch = chooseRand2("riverSandyC", "sandDirt50");
		tForest = "Palm Forest";
		
		sLight = "default";

		sDeco1 = "Rock Sandstone Sprite";
		sDeco2 = "Rock Sandstone Small";
		
		sMU1 = chooseRand3("Wadjet", "Anubite", "Sphinx");
		iMU1Cost = 3;
		sMU2 = chooseRand4("Scarab", "Petsuchos", "Mummy", "Avenger");
		if(sMU2=="Scarab") {iMU2Cost = 9;} else if(sMU2=="Petsuchos") {iMU2Cost = 9;} else {iMU2Cost = 11;}
		sHero = "Pharaoh";
		sHeroCost = 4;
		sSoldier1 = chooseRand3("Spearman", "Axeman", "Slinger");
		iSoldier1Cost = 1;
		sSoldier2 = chooseRand2("Chariot Archer", "Camelry");
		iSoldier2Cost = 2;

		name1 = "Spear"; if(sSoldier1=="Slinger") {name1="Sling";}
		name2 = "Chariot"; if(sSoldier1=="Camel") {name2="Camel";}
		sEnvUnitsDesc = "Pharaoh(4), "+name1+"(1), "+name2+"(2), "+sMU1+"("+iMU1Cost+"), "+sMU2+"("+iMU2Cost+")";
		
		sEnvPower = chooseRand2("Meteor", "Tornado");
		iEnvPowerCaster = "Setna";
		iEnvPowerCost = 35;
		
		sEnvPowerDesc = "Setna="+sEnvPower+"("+iEnvPowerCost+")";
	}
	else if(env==GREEK_ENV) {
		tBlack = "water";
		sSea = "Mediterranean Sea";
		tPlayer = "greekRoadA";
		tConn = "greekRoadA";
		tMiddle = "grassA";
		tDecoPatch = chooseRand2("grassDirt50", "riverGrassyC");
		tForest = "Mixed Oak Forest";
		
		sLight = "default";

		sDeco1 = "Ruins";
		sDeco2 = "Flowers";
		
		sMU1 = chooseRand2("Centaur", "Minotaur");
		iMU1Cost = 3;
		sMU2 = chooseRand3("Hydra", "Medusa", "Colossus");
		if(sMU2=="Hydra") {iMU2Cost = 11;} else if(sMU2=="Medusa") {iMU2Cost=11;} else {iMU2Cost = 13;}
		sHero = chooseRand2("Hero Greek Hippolyta", "Hero Greek Atalanta");
		sHeroCost = 4;
		sSoldier1 = chooseRand2("Toxotes", "Hoplite");
		iSoldier1Cost = 1;
		sSoldier2 = chooseRand3("Crossbowman", "Myrmidon", "Hetairoi");
		iSoldier2Cost = 2;

		name3 = "Hippolyta"; if(sSoldier1=="Hero Greek Atalanta") {name1="Atalanta";}
		name1 = "Tox."; if(sSoldier1=="Hoplite") {name1="Hop.";}
		name2 = "Myrm."; if(sSoldier1=="Crossbowman") {name2="Gastr.";} 
				 if(sSoldier1=="Hetairoi") {name2="Heta.";}
		sEnvUnitsDesc = name3+"(4), "+name1+"(1), "+name2+"(2), "+sMU1+"("+iMU1Cost+"), "+sMU2+"("+iMU2Cost+")";
		
		sEnvPower = chooseRand2("Bronze", "Curse");
		iEnvPowerCaster = "Agamemnon";
		if(sEnvPower=="Bronze") {iEnvPowerCost = 30;}
		else {iEnvPowerCost = 20;}

		sEnvPowerDesc = "Agamemnon="+sEnvPower+"("+iEnvPowerCost+")";
	}
	else if(env==HADES_ENV) {
		fBaseHeight = 7.5;
		tBlack = "hadesCliff";
		tCliff = "hadesCliff";
		tBlackPatch = "hades3";
		tBlackPatch2 = "hades4";
		sSea = "Mediterranean Sea";
		tPlayer = "hadesBuildable2";
		tConn = "hadesBuildable2";
		tMiddle = "hadesBuildable2";
		tDecoPatch = chooseRand2("hades9", "hades8");
		tForest = "Hades Forest";
		
		sLight = "erebus";

		sDeco1 = "Skeleton";
		sDeco2 = "Ruins";
		sBlackPatchDeco = "Fire Hades";
		iBlackPatchDecoAmount = 350;
		
		sMU1 = chooseRand2("Cyclops", "Einheriar");
		iMU1Cost = 4;
		sMU2 = chooseRand3("Chimera", "Nemean Lion", "Manticore");
		if(sMU2=="Chimera") {iMU2Cost = 11;} else {iMU2Cost = 9;}
		sHero = chooseRand2("Hero Greek Chiron", "Hero Greek Heracles");
		sHeroCost = 4;
		sSoldier1 = "Shade of Hades";
		iSoldier1Cost = 1;
		sSoldier2 = chooseRand3("Crossbowman", "Myrmidon", "Hetairoi");
		iSoldier2Cost = 2;

		name1 = "Myrm."; if(sSoldier1=="Crossbowman") {name1="Gastr.";} 
				 if(sSoldier1=="Hetairoi") {name1="Heta.";}
		name2 = "Einh."; if(sMU1=="Cyclops") {name2="Cyclops";} 
		name3 = "N.Lion"; if(sMU2!="Nemean Lion") {name3=sMU2;} 
		name4 = "Chiron"; if(sHero=="Hero Greek Heracles") name4="Heracles";
		sEnvUnitsDesc = name4+"(4), Shade(1), "+name1+"(2), "+name2+"("+iMU1Cost+"), "+name3+"("+iMU2Cost+")";
		
		sEnvPower = chooseRand2("Skeleton Power", "Meteor");
		iEnvPowerCaster = "Gargarensis";
		iEnvPowerCost = 30; if(sEnvPower=="Meteor") {iEnvPowerCost=35;}

		name1 = "Ancestors"; if(sEnvPower=="Meteor") {name1="Meteor";} 
		sEnvPowerDesc = "Gargarensis="+name1+"("+iEnvPowerCost+")";
	}

	// Init map.
	rmSetSeaType(sSea);
	rmTerrainInitialize(tBlack);
	rmSetLightingSet(sLight);
	rmSetGaiaCiv(cCivIsis);
	
	// map generation progress
	rmSetStatusText("",0.05);
	
	int clPlayer = rmDefineClass("clPlayer");
	int clMiddle = rmDefineClass("clMiddle");
	int clFountain = rmDefineClass("clFountain");
	int clDecoPatch = rmDefineClass("clDecoPatch");
	int clForest = rmDefineClass("clForest");
	int clBlackPatch2 = rmDefineClass("clBlackPatch");
	
	int cnsPlayers=rmCreateClassDistanceConstraint("avoidPlayers", clPlayer, 7);
	int cnsMiddle=rmCreateClassDistanceConstraint("avoidMiddle", clMiddle, 7);
	int cnsFountain=rmCreateClassDistanceConstraint("avoidFountain", clFountain, 5);
	int cnsForest=rmCreateClassDistanceConstraint("avoidForest", clForest, 4);
	int cnsEdge = rmCreateBoxConstraint("edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10),
		1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10));
	
	rmSetPlayerPlacementArea(0,0, 1,1);
	rmPlacePlayersCircular(0.47-rmXTilesToFraction(30),0.47-rmXTilesToFraction(30),rmDegreesToRadians(1));
	
	// map generation progress
	rmSetStatusText("",0.10);
	
	id = rmCreateArea("middle");
	rmAddAreaToClass(id, clMiddle);
	sz = (0.91-rmXTilesToFraction(85))*(0.91-rmXTilesToFraction(85))*3.14/4;
	rmSetAreaSize(id, sz, sz);
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight+0.5);
	rmSetAreaHeightBlend(id, 1);
	//if(tCliff != "") {
	//	rmAddAreaTerrainLayer(id, tCliff, (0.91-rmXTilesToFraction(80)),(0.91-rmXTilesToFraction(85)));
	//}
	rmBuildArea(id);
	rmEchoInfo("Built middle area");
	
	id = rmCreateArea("fountainDummy");
	rmAddAreaToClass(id, clFountain);
	rmSetAreaSize(id, rmAreaTilesToFraction(100+cNumberPlayers*25), rmAreaTilesToFraction(100+cNumberPlayers*25));
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight+0.5);
	rmSetAreaHeightBlend(id, 0);
	rmBuildArea(id);
	rmEchoInfo("Built fountain dummy area");

	k = cNumberPlayers*3;
	k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
	for(i=0; <k) {
		id = rmCreateArea("decoPatch"+i, rmAreaID("middle"));
		rmAddAreaToClass(id, clDecoPatch);
		rmSetAreaSize(id, rmAreaTilesToFraction(10), rmAreaTilesToFraction(40));
		rmSetAreaTerrainType(id, tDecoPatch);
		rmAddAreaConstraint(id, cnsFountain);
		rmSetAreaCoherence(id, 0);
		rmSetAreaBaseHeight(id, fBaseHeight+rmRandInt(5,15)/10.0*0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built deco patch area "+i);
	}
	
	k = cNumberPlayers*5;
	k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
	for(i=0; <k) {
		id = rmCreateArea("forest"+i, rmAreaID("middle"));
		rmAddAreaToClass(id, clForest);
		rmSetAreaSize(id, rmAreaTilesToFraction(1), rmAreaTilesToFraction(10));
		rmSetAreaForestType(id, tForest);
		rmAddAreaConstraint(id, cnsFountain);
		rmAddAreaConstraint(id, cnsForest);
		rmSetAreaCoherence(id, 0);
		rmSetAreaBaseHeight(id, fBaseHeight+rmRandInt(5,15)/10.0*0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built deco patch area "+i);
	}

	for(i=1; <cNumberPlayers) {
		id = rmCreateArea("player"+i);
		rmSetPlayerArea(i,id);
		rmAddAreaToClass(id, clPlayer);
		rmAddAreaConstraint(id, cnsMiddle);
		rmSetAreaSize(id, rmAreaTilesToFraction(480), rmAreaTilesToFraction(480));
		rmSetAreaTerrainType(id, tPlayer);
		rmSetAreaCoherence(id, 1);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaBaseHeight(id, fBaseHeight+0.5);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built home area for player "+i);
		
		id = rmCreateConnection("connect"+i);
		rmAddConnectionArea(id, rmAreaID("player"+i));
		rmAddConnectionArea(id, rmAreaID("middle"));
		rmSetConnectionWidth(id, 28);
		if(tCliff!="") {rmSetConnectionWidth(id, 20);}
		rmSetConnectionBaseHeight(id, fBaseHeight+0.5);
		rmSetConnectionHeightBlend(id, 1);
		if(tBlackPatch!="") rmSetConnectionHeightBlend(id,0);
		rmAddConnectionTerrainReplacement(id, tBlack, tConn);
		rmAddConnectionTerrainReplacement(id, "blackRock", tConn);
		rmAddConnectionTerrainReplacement(id, "black", tConn);
		rmAddConnectionToClass(id, clPlayer);
		rmBuildConnection(id);
	}
	
	id = rmCreateArea("fountainMound");
	rmAddAreaToClass(id, clFountain);
	rmSetAreaSize(id, rmAreaTilesToFraction(100+cNumberPlayers*25), rmAreaTilesToFraction(100+cNumberPlayers*25));
	rmSetAreaTerrainType(id, tMiddle);
	rmSetAreaCoherence(id, 1);
	rmSetAreaLocation(id, 0.5, 0.5);
	rmSetAreaBaseHeight(id, fBaseHeight+3.5);
	rmSetAreaHeightBlend(id, 1);
	rmBuildArea(id);
	rmEchoInfo("Built fountain mound area");
	
	// map generation progress
	rmSetStatusText("",0.20);
	
	for(i=1; <cNumberPlayers) {
		id = rmCreateArea("special"+i);
		rmAddAreaToClass(id, clPlayer);
		float x = (0.5 + rmXTilesToFraction(54))/0.5;
		float z = (0.5 + rmZTilesToFraction(54))/0.5;
		setSpecialX(i, (rmPlayerLocXFraction(i)-0.5)*x+0.5);
		setSpecialZ(i, (rmPlayerLocZFraction(i)-0.5)*z+0.5);
		rmEchoInfo("For player "+i+" special area, x="+getSpecialX(i)+" and z="+getSpecialZ(i));
		rmSetAreaLocation(id, getSpecialX(i), getSpecialZ(i));
		rmSetAreaSize(id, rmAreaTilesToFraction(130), rmAreaTilesToFraction(130));
		rmSetAreaTerrainType(id, tPlayer);
		rmSetAreaCoherence(id, 1);
		rmSetAreaBaseHeight(id, fBaseHeight+1.0);
		rmSetAreaHeightBlend(id, 1);
		rmBuildArea(id);
		rmEchoInfo("Built special area for player "+i);
	}
	
	// map generation progress
	rmSetStatusText("",0.30);
	
	if(tBlackPatch != "") {
		for(i=1; <30) {
			id = rmCreateArea("blackPatch"+i,-1);
			rmSetAreaSize(id, 0.15, 0.2);
			rmSetAreaMinBlobs(id, 25);
			rmSetAreaMaxBlobs(id, 35);
			rmSetAreaMinBlobDistance(id, 0.0);
			rmSetAreaMaxBlobDistance(id, 55.0);
			rmAddAreaTerrainReplacement(id, tBlack, tBlackPatch);
			rmSetAreaCoherence(id, 0);
			rmAddAreaConstraint(id, cnsPlayers);
			rmAddAreaConstraint(id, cnsMiddle);
			rmBuildArea(id);
		}
		for(i=1; <300) {
			id = rmCreateArea("blackPatch2_"+i,-1);
			rmSetAreaSize(id, 0.0005, 0.001);
			rmAddAreaTerrainReplacement(id, tBlackPatch, tBlackPatch2);
			rmSetAreaCoherence(id, 0);
			rmAddAreaConstraint(id, cnsPlayers);
			rmAddAreaConstraint(id, cnsMiddle);
			rmAddAreaToClass(id, clBlackPatch2);
			rmBuildArea(id);
		}
	}
	
	rmBuildAllAreas();
	
	// map generation progress
	rmSetStatusText("",0.35);

	for(i=1; <cNumberPlayers) {
		rmSetPlayerResource(i, "food", 0);
		rmSetPlayerResource(i, "wood", 0);
		rmSetPlayerResource(i, "gold", 0);
		rmSetPlayerResource(i, "favor", 10);
	}
	
	for(i=1; <cNumberPlayers) {
		id=rmCreateObjectDef("home"+i);
		rmAddObjectDefItem(id, "Hill Fort", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		setHome(i, rmCreateArmy(i, "home"+i));
		rmAddUnitsToArmy(i, getHome(i),id);
		
		id=rmCreateObjectDef("cameraStart"+i);
		rmAddObjectDefItem(id, "Camera Start", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		id=rmCreateObjectDef("startMarker"+i);
		rmAddObjectDefItem(id, "Revealer to Player", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		k=rmGetUnitPlaced(id,0);
		setStart(i, ""+k);

		k = rmRandInt(4,7);
		for(j=1; <k) {
			id=rmCreateObjectDef("decoWeapons"+i+"_"+j);
			rmAddObjectDefItem(id, "Weapons", 1, 0.0);
			rmSetObjectDefMinDistance(id, 4.0);
			rmSetObjectDefMaxDistance(id, 13.0);
			rmPlaceObjectDefAtLoc(id, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}

		k = rmRandInt(1,1);
		for(j=1; <=k) {
			id=rmCreateObjectDef("decoGlow"+i+"_"+j);
			rmAddObjectDefItem(id, "Osiris Box Glow", 1, 0.0);
			rmSetObjectDefMinDistance(id, 0.0);
			rmSetObjectDefMaxDistance(id, 0.0);
			rmPlaceObjectDefAtLoc(id, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		}
	}
	
	for(i=1; <cNumberPlayers) {
		id=rmCreateObjectDef("monument"+i);
		rmAddObjectDefItem(id, "Monument 2", 1, 0.0);
		rmSetObjectDefMinDistance(id, 0.0);
		rmSetObjectDefMaxDistance(id, 0.0);
		rmPlaceObjectDefAtLoc(id, 0, getSpecialX(i), getSpecialZ(i));
		k=rmGetUnitPlaced(id,0);
		setMonument(i, ""+k);		
	}
	
	for(i=1; <cNumberPlayers) {
		setArmy(i, rmCreateArmy(i, "army"+i));
	}
	
	if(sBlackPatchDeco!="") {
		k = sqrt(cNumberPlayers)*iBlackPatchDecoAmount;
		k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
		for(i=1; <k) {
			id=rmCreateObjectDef("blackPatchDeco_"+i);
			rmAddObjectDefItem(id, sBlackPatchDeco, 1, 0.0);
			rmSetObjectDefMinDistance(id, 0);
			rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.01));
			rmAddObjectDefConstraint(id, cnsPlayers);
			rmAddObjectDefConstraint(id, cnsMiddle);
			rmPlaceObjectDefInRandomAreaOfClass(id, 0, clBlackPatch2, 1);
		}
	}

	k = cNumberPlayers*2;
	k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
	for(i=1; <k) {
		id=rmCreateObjectDef("deco1_"+i);
		rmAddObjectDefItem(id, sDeco1, 1, 0.0);
		rmSetObjectDefMinDistance(id, 15);
		rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.5));
		rmAddObjectDefConstraint(id, cnsPlayers);
		rmAddObjectDefConstraint(id, cnsFountain);
		rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5);
	}

	k = cNumberPlayers*2;
	k = k + rmRandInt(0-cNumberPlayers, cNumberPlayers);
	for(i=1; <k) {
		id=rmCreateObjectDef("deco2_"+i);
		rmAddObjectDefItem(id, sDeco2, 1, 0.0);
		rmSetObjectDefMinDistance(id, 15);
		rmSetObjectDefMaxDistance(id, rmXFractionToTiles(0.5));
		rmAddObjectDefConstraint(id, cnsPlayers);
		rmAddObjectDefConstraint(id, cnsFountain);
		rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5);
	}
	
	// map generation progress
	rmSetStatusText("",0.40);

	id = rmCreateTrigger("init_gaia1");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(4);
	for(j=0; <40) {
		grantTech(0, cTechRelicNoseoftheSphinx);
	}
	if(env==NORSE_ENV){ 
		rmAddTriggerEffect("Render Snow");
		 rmSetTriggerEffectParamFloat("Percent",0.20);
	}	
	for(i=1; <cNumberPlayers) {
		rmAddTriggerEffect("Player Kill All God Powers");
		 rmSetTriggerEffectParamInt("Player", i, false);
	}

	id = rmCreateTrigger("init_gaia2a");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 4, false);
	for(i=1; <2) {	// just for p1 to reduce lag
		rmAddTriggerEffect("Grant God Power");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParamInt("Count", 1, false);
		 rmSetTriggerEffectParam("PowerName", "Vision", false);
		rmAddTriggerEffect("Invoke God Power");
		 rmSetTriggerEffectParamInt("PlayerID", i, false);
		 rmSetTriggerEffectParam("DstPoint1", pointLoc(0.5,0.5), false);
		 rmSetTriggerEffectParam("PowerName", "Vision", false);
	}

	id = rmCreateTrigger("init_gaia2b");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 7, false);
	rmAddTriggerEffect("Grant God Power");
	 rmSetTriggerEffectParamInt("PlayerID", 1, false);
	 rmSetTriggerEffectParamInt("Count", 1, false);
	 rmSetTriggerEffectParam("PowerName", "Healing Spring", false);
	rmAddTriggerEffect("Invoke God Power");
	 rmSetTriggerEffectParamInt("PlayerID", 1, false);
	 rmSetTriggerEffectParam("DstPoint1", pointLoc(0.5,0.5), false);
	 rmSetTriggerEffectParam("PowerName", "Healing Spring", false);

	id = rmCreateTrigger("init_gaia2c");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 12, false);
	rmAddTriggerEffect("Player Kill All God Powers");
	 rmSetTriggerEffectParamInt("Player", 1, false);

	id = rmCreateTrigger("instructions1");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 0, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "Welcome to Norse Wars version 2.0 by Matei! Please read here for instructions.", false);
	rmAddTriggerEffect("Sound Filename");
	 rmSetTriggerEffectParam("Sound", "lightningstrike3.wav", false);

	id = rmCreateTrigger("instructions2");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 8, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "Protect your Hill Fort to survive, while trying to destroy the enemy Hill Forts.", false);
	for(i=1; <cNumberPlayers) {
		rmAddTriggerEffect("Flare Minimap");
		 rmSetTriggerEffectParamInt("PlayerID", i, false); 
		 rmSetTriggerEffectParamFloat("Duration", 3.0, false); 
		 rmSetTriggerEffectParam("Position", playerLoc(i), false);
	}

	id = rmCreateTrigger("instructions3");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 16, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "Units spawn regularly in your base. You get more units if you hold favor in your stockpile."+" Your population limit is 160.", false);
	for(i=1; <cNumberPlayers) {
		rmAddTriggerEffect("Flare Minimap");
		 rmSetTriggerEffectParamInt("PlayerID", i, false); 
		 rmSetTriggerEffectParamFloat("Duration", 3.0, false); 
		 rmSetTriggerEffectParam("Position", playerGatherLoc(i), false);
	}

	id = rmCreateTrigger("instructions4");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 24, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "Obtain favor by fighting (note that only human soldiers and Shades generate favor this way).", false);
	for(i=1; <cNumberPlayers) {
		rmAddTriggerEffect("Flare Minimap");
		 rmSetTriggerEffectParamInt("PlayerID", i, false); 
		 rmSetTriggerEffectParamFloat("Duration", 3.0, false); 
		 rmSetTriggerEffectParam("Position", pointLoc(0.5, 0.5), false);
	}

	id = rmCreateTrigger("instructions5");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 32, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "You can also use favor to buy god powers, upgrades and special units on your store island."+" Read below for details:", false);
	for(i=1; <cNumberPlayers) {
		rmAddTriggerEffect("Flare Minimap");
		 rmSetTriggerEffectParamInt("PlayerID", i, false); 
		 rmSetTriggerEffectParamFloat("Duration", 3.0, false); 
		 rmSetTriggerEffectParam("Position", pointLoc(getSpecialX(i), getSpecialZ(i)), false);
	}

	id = rmCreateTrigger("instructions6");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 40, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 9000, false); 
	 rmSetTriggerEffectParam("Text", "Now go forth to battle, and may the Norse gods smile upon you!", false);
	rmAddTriggerEffect("Sound Filename");
	 rmSetTriggerEffectParam("Sound", "cinematics\04_in\armyarrive.wav", false);

	// map generation progress
	rmSetStatusText("",0.45);

	// diplomacy init
	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("init_p"+i+"__diplo");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 3, false);
		rmAddTriggerEffect("Diplomacy");
		 rmSetTriggerEffectParam("Status", "ally", false);
		 rmSetTriggerEffectParamInt("Player1", i, false);
		 rmSetTriggerEffectParamInt("Player2", 0, false);
	}

	// starting techs, distributed over time to prevent lag
	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("init_p"+i+"_a");
		rmSwitchToTrigger(id);
		rmSetTriggerRunImmediately(true);
		removeTech(i, cTechStartingResourcesEgyptian-1);
		removeTech(i, cTechStartingResourcesGreek-1);
		removeTech(i, cTechStartingResourcesNorse-1);
		grantTech(i, cTechAge2Heimdall);
		grantTech(i, cTechAge3Njord);
		grantTech(i, cTechAge4Baldr);
		rmAddTriggerEffect("Player Kill All God Powers");
		 rmSetTriggerEffectParamInt("Player", i, false);
		grantTech(i, cTechSignalFires);
		grantTech(i, cTechSignalFires);
		grantTech(i, cTechCrenellations-1);
		for(j=1; <=15) {
		grantTech(i, cTechRelicArrowsofAlfar);
		}

		id = rmCreateTrigger("init_p"+i+"_c");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 5, false);
		grantTech(i, cTechMediumArchers);
		grantTech(i, cTechHeavyArchers);
		grantTech(i, cTechChampionArchers);
		grantTech(i, cTechMediumInfantry);
		grantTech(i, cTechHeavyInfantry);
		grantTech(i, cTechChampionInfantry);
		grantTech(i, cTechMediumSlingers);
		grantTech(i, cTechHeavySlingers);
		grantTech(i, cTechChampionSlingers);
		grantTech(i, cTechMediumAxemen);
		grantTech(i, cTechHeavyAxemen);
		grantTech(i, cTechChampionAxemen);
		grantTech(i, cTechMediumSpearmen);
		grantTech(i, cTechHeavySpearmen);
		grantTech(i, cTechChampionSpearmen);

		id = rmCreateTrigger("init_p"+i+"_d");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 6, false);
		grantTech(i, cTechLabyrinthofMinos);
		grantTech(i, cTechShoulderofTalos);
		grantTech(i, cTechFaceoftheGorgon);
		grantTech(i, cTechBurningPitch);
		grantTech(i, cTechFeetoftheJackal);
		grantTech(i, cTechFlamesofTyphon);
		grantTech(i, cTechCrocodopolis-1);
		grantTech(i, cTechAtefCrown-1);

		id = rmCreateTrigger("init_p"+i+"_e");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 8, false);
		grantTech(i, cTechBoilingOil);
		grantTech(i, cTechHamarrtroll);
		grantTech(i, cTechAuroraBorealis);
		grantTech(i, cTechEldhrimnirKettle);
		grantTech(i, cTechRime);
		grantTech(i, cTechSylvanLore);
		grantTech(i, cTechCriosphinx);
		grantTech(i, cTechRoarofOrthus-1);

		id = rmCreateTrigger("init_p"+i+"_f");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 9, false);
		grantTech(i, cTechMediumCavalry);
		grantTech(i, cTechHeavyCavalry);
		grantTech(i, cTechChampionCavalry);
		grantTech(i, cTechHeavyCamelry);
		grantTech(i, cTechChampionCamelry);
		grantTech(i, cTechHeavyChariots-1);
		grantTech(i, cTechChampionChariots-1);
		grantTech(i, cTechHallofThanes-1);
		grantTech(i, cTechWeaponoftheTitans-1);

		id = rmCreateTrigger("init_p"+i+"_g");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 10, false);
		for(j=0; <=13) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}

		id = rmCreateTrigger("init_p"+i+"_h");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 11, false);
		for(j=0; <=13) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}

		id = rmCreateTrigger("init_p"+i+"_i");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 12, false);
		for(j=0; <=13) {
			grantTech(i, cTechRelicNoseoftheSphinx);
		}


		id = rmCreateTrigger("init_p"+i+"_j");
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 13, false);
		for(j=0; <=8) {
			grantTech(i, cTechMasons);
		}

		// bonus techs
		id = rmCreateTrigger("bonus_p"+i);
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Timer");
		 rmSetTriggerConditionParamInt("Param1", 1, false);
		if(rmGetPlayerCiv(i)==cCivThor) {
			grantTech(i, cTechCopperMail);
			grantTech(i, cTechCopperShields);
		}
		else if(rmGetPlayerCiv(i)==cCivOdin) {
			grantTech(i, cTechBacchanalia);
		}
		else if(rmGetPlayerCiv(i)==cCivLoki) {
			grantTech(i, cTechThurisazRune-1);
			grantTech(i, cTechThurisazRune-1);
			grantTech(i, cTechThurisazRune-1);
			grantTech(i, cTechLoneWanderer);
		}
	}	
	
	
	// map generation progress
	rmSetStatusText("",0.50);

	for(i=1; <cNumberPlayers) {
		if(rmGetPlayerCulture(i)!=cCultureNorse) {
			id = rmCreateTrigger("warnCulture_p"+i);
			rmSwitchToTrigger(id);
			rmAddTriggerCondition("Timer");
			 rmSetTriggerConditionParamInt("Param1", 1, false);
			sendChat("<Player "+i+", you cannot gain favor since you are not Norse!>", i);
		}
	}

	for(i=1; <cNumberPlayers) {
		id = rmCreateTrigger("lost_p"+i);
		rmSwitchToTrigger(id);
		rmAddTriggerCondition("Army Is Dead");
		 rmSetTriggerConditionParamArmy("SrcArmy", i, getHome(i), false);
		sendChat("<Player "+i+" has been defeated!>", i);
		rmAddTriggerEffect("Sound Filename");
		 rmSetTriggerEffectParam("Sound", "meteorbighit.wav", false);
		//rmAddTriggerEffect("Player Destroy All Units");
		// rmSetTriggerEffectParamInt("Player", i, false);
		rmAddTriggerEffect("Player Destroy All Buildings");
		 rmSetTriggerEffectParamInt("Player", i, false);
		rmAddTriggerEffect("Set Player Defeated");
		 rmSetTriggerEffectParamInt("Player", i, false);
	}

	
	
	// map generation progress
	rmSetStatusText("",0.55);
	
	addRavens(16);
	
	addSpawningUnit("Ulfsark", 1, 2, 0);
	addSpawningUnit("Throwing Axeman", 1, 5, 15);
	addSpawningUnit("Raiding Cavalry", 1, 6, 30);
	addSpawningUnit("Huskarl", 1, 5, 45);
	addSpawningUnit("Toxotes", 1, 4, 60);
	addSpawningUnit("Jarl", 1, 6, 75);
	
	// map generation progress
	rmSetStatusText("",0.65);
	
	addBuyableUnit(sMU1, iMU1Cost, 1);
	addBuyableUnit(sMU2, iMU2Cost, 1);	
	addBuyableUnit(sSoldier1, iSoldier1Cost, 0);
	addBuyableUnit(sSoldier2, iSoldier2Cost, 0);	
	addBuyableUnit(sHero, sHeroCost, 0);
	
	// map generation progress
	rmSetStatusText("",0.75);
	
	addGodPowerUnit("Arkantos", "Lightning Storm", 30);
	addGodPowerUnit("Kastor", "Restoration", 30);
	addGodPowerUnit("Amanra", "SandStorm", 15);
	addGodPowerUnit(iEnvPowerCaster, sEnvPower, iEnvPowerCost);
	
	// map generation progress
	rmSetStatusText("",0.85);
	
	addTechUnit("Skult", cTechIronWeapons, 19);
	addTechUnit("Brokk", cTechIronMail, 15);
	addTechUnit("Eitri", cTechIronShields, 15);
	
	// map generation progress
	rmSetStatusText("",0.95);
	
	// looping instructions

	id = rmCreateTrigger("instructions_loop1");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(3);
	rmSetTriggerActive(false);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 48, false);
	sendChat("FAVOR TO HOLD FOR FREE AUTO-SPAWNING UNITS:");
	sendChat("Ulfsark-0, T.Axe-15, R.Cav-30, Husk.-45, Tox.-60, Jarl-75");
	sendChat("(Tip: Delete weaker units when at pop. limit to get others)");
	k = id;

	id = rmCreateTrigger("instructions_loop1_start");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 16, false);
	sendChat("FAVOR TO HOLD FOR FREE AUTO-SPAWNING UNITS:");
	sendChat("Ulfsark-0, T.Axe-15, R.Cav-30, Husk.-45, Tox.-60, Jarl-75");
	sendChat("(Tip: Delete weaker units when at pop. limit to get others)");
	rmAddTriggerEffect("Fire Event");
	 rmSetTriggerEffectParam("EventID", ""+k, false);

	id = rmCreateTrigger("instructions_loop2");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerActive(false);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 48, false);
	sendChat("COSTS FOR STORE ISLAND: (move a unit to monument to buy)");
	sendChat("Units: "+sEnvUnitsDesc);
	sendChat("Upgrades: Skult=Weapons(19), Brokk=Mail(15), Eitri=Shields(15)");
	sendChat("God Powers: Arkantos=L.Storm(30), Amanra=S.Sands(15) "+"Kastor=Restoration(30), "+sEnvPowerDesc);
	k = id;

	id = rmCreateTrigger("instructions_loop2_start");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 32, false);
	sendChat("COSTS FOR STORE ISLAND: (move a unit to monument to buy)");
	sendChat("Units: "+sEnvUnitsDesc);
	sendChat("Upgrades: Skult=Weapons(19), Brokk=Mail(15), Eitri=Shields(15)");
	sendChat("God Powers: Arkantos=L.Storm(30), Amanra=S.Sands(15) "+"Kastor=Restoration(30), "+sEnvPowerDesc);
	rmAddTriggerEffect("Fire Event");
	 rmSetTriggerEffectParam("EventID", ""+k, false);

	id = rmCreateTrigger("instructions_loop3");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmSetTriggerPriority(3);
	rmSetTriggerActive(false);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 48, false);
	sendChat("CIV BONUSES: (all decreased costs rounded downward)");
	sendChat("THOR: Starts with copper armor/shields, upgrades cost -10%%");
	sendChat("ODIN: Free Ravens, units self-heal, units +5%% HP, GP's cost -5%%");
	sendChat("LOKI: Myth units cost -20%%, 36%% faster; Ulfsarks 10%% faster");
	k = id;

	id = rmCreateTrigger("instructions_loop3_start");
	rmSwitchToTrigger(id);
	rmSetTriggerPriority(3);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 48, false);
	sendChat("CIV BONUSES: (all decreased costs rounded downward)");
	sendChat("THOR: Starts with copper armor/shields, upgrades cost -10%%");
	sendChat("ODIN: Free Ravens, units self-heal, units +5%% HP, GP's cost -5%%");
	sendChat("LOKI: Myth units cost -20%%, 36%% faster; Ulfsarks 10%% faster");
	rmAddTriggerEffect("Fire Event");
	 rmSetTriggerEffectParam("EventID", ""+k, false);
	 
	// author acknowledgement

	id = rmCreateTrigger("author_loop");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	rmAddTriggerCondition("Timer");
	 rmSetTriggerConditionParamInt("Param1", 240, false);
	rmAddTriggerEffect("Message");
	 rmSetTriggerEffectParamInt("Timeout", 12000, false); 
	 rmSetTriggerEffectParam("Text", "Norse Wars is a map by Matei of Woad Creations. Visit us at www.woadcreations.com.", false);

	// random battle music triggers

	id = rmCreateTrigger("musicStop_initial");	// stop game music
	rmSwitchToTrigger(id);
	rmSetTriggerRunImmediately(true);
	rmAddTriggerEffect("Music Stop");

	id = rmCreateTrigger("musicStop_loop");
	rmSwitchToTrigger(id);
	rmSetTriggerLoop(true);
	//rmAddTriggerCondition("Timer");
	// rmSetTriggerConditionParamInt("Param1", 1, false);
	rmAddTriggerEffect("FadeOutMusic");
	
	i = NUM_MUSICS;
	name1 = "";
	while(true) {	
		if(i==0) { break; }

		if(i==1) {
			name1 = "\music\culture\of norse not!.mp3";
		}
		else {
			while(true) {
				name2 = chooseRand2(
					chooseRand4("\music\fight\meatier shower.mp3",
						"\music\fight\oi, that pops!!!.mp3",
						"\music\fight\i wish i could throw shapes.mp3",
						"\music\fight\the fire brigade.mp3"),
					chooseRand4("\music\fight\rot loaf.mp3",
						"\music\fight\li'l drips.mp3",
						"\music\interface\if you can use a doorknob.mp3",
						"\music\interface\gank sneakin'.mp3")
				);
				if(name2 != name1) {
					name1 = name2; break;
				}
				// else continue
			}
		}

		id = rmCreateTrigger("music_"+i);
		rmSwitchToTrigger(id);
		rmSetTriggerPriority(5);
		if(i != 1) {
			rmSetTriggerActive(false);
		}
		if(i != NUM_MUSICS) {
		rmAddTriggerEffect("Sound Filename");
		 rmSetTriggerEffectParam("Sound", name1, false);
		 rmSetTriggerEffectParam("EventID", ""+nextMusicID, false);
		}
		
		if(i==2) {
			secondMusicID = id;
		}
		if(i==NUM_MUSICS) {
			lastMusicID = id;
		}

		nextMusicID = id;
		i--;
	}
	
	// loop back to track 2 when last trigger fires
	rmSwitchToTrigger(lastMusicID);
	rmAddTriggerEffect("Fire Event");
	 rmSetTriggerEffectParam("EventID", ""+secondMusicID, false);

	// map generation progress
	rmSetStatusText("",1.00);
}
